/**
 * DzNode.h
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#if !defined(AFX_DZNODE_H__B7731633_675D_4B49_98D7_EE516ADAC516__INCLUDED_)
#define AFX_DZNODE_H__B7731633_675D_4B49_98D7_EE516ADAC516__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDzNode  
{
public:
  enum nodetypes {
    nt_none,
    nt_document,
    nt_section,
    nt_outer,
    nt_inner
  };
private:
  std::string dz_cmd;
  std::string dz_class;
  std::string dz_id;
  nodetypes dz_type;
  std::vector<std::string> dz_vars;
  int dz_level;
public:
  CDzNode() {
    dz_type = nodetypes::nt_none;
    dz_level = 0;
  };
  CDzNode(std::string s_cmd, std::string s_class = "", std::string s_id ="", std::vector<std::string> s_vars = std::vector<std::string>(), nodetypes s_type = nt_none, int s_level = 1) :
    dz_cmd(s_cmd), dz_class(s_class), dz_id(s_id), dz_vars(s_vars), dz_type(s_type), dz_level(s_level) {};
  CDzNode(const CDzNode &dzNode) {
    dz_cmd = dzNode.dz_cmd;
    dz_class = dzNode.dz_class;
    dz_id = dzNode.dz_id;
    dz_vars = dzNode.dz_vars;
    dz_type = dzNode.dz_type;
    dz_level = dzNode.dz_level;
  };
  virtual ~CDzNode() { };

  void set_cmd(std::string str) { dz_cmd = str; }
  void set_class(std::string str) { dz_class = str; }
  void set_id(std::string str) { dz_id = str; }
  void add_vars(std::string str) { dz_vars.push_back(str); }
  void set_vars(std::vector<std::string> v_str) { dz_vars = v_str; }
  void set_type(nodetypes type) { dz_type = type; }
  void add_level(void) { ++dz_level; }
  void set_cmd(LPCSTR str) { dz_cmd = str; }
  void set_class(LPCSTR str) { dz_class = str; }
  void set_id(LPCSTR str) { dz_id = str; }
  void add_vars(LPCSTR str) { dz_vars.push_back(str); }

  std::string get_cmd(void) { return dz_cmd; }
  std::string get_class(void) { return dz_class; }
  std::string get_id(void) { return dz_id; }
  int get_vars_length(void) { return dz_vars.size(); }
  std::string get_vars_at(int i) { return dz_vars[i]; }
  nodetypes get_type(void) { return dz_type; }
  int get_level(void) { return dz_level; }
};

#endif // !defined(AFX_DZNODE_H__B7731633_675D_4B49_98D7_EE516ADAC516__INCLUDED_)
