/**
 * DzScript.h
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#if !defined(AFX_DZSCRIPT_H__373952F1_BA12_4F8D_8F3F_F8F3D46A48DE__INCLUDED_)
#define AFX_DZSCRIPT_H__373952F1_BA12_4F8D_8F3F_F8F3D46A48DE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDzScript  
{
private:
  std::string account;
  std::string script_host;
  std::string script_name;
  std::string script_option;
  std::string script_ext;
  UINT script_id;
public:
  CDzScript() { };
  virtual ~CDzScript() { };

  void set_account(std::string s_account) { account = s_account; }
  void set_script_host(std::string s_script_host) { script_host = s_script_host; }
  void set_script_name(std::string s_script_name) { script_name = s_script_name; }
  void set_script_option(std::string s_script_option) { script_option = s_script_option; }
  void set_script_id(UINT s_script_id) { script_id = s_script_id; }
  void set_script_ext(std::string s_script_ext) { script_ext = s_script_ext; }

  HRESULT set_script(std::string line, UINT uid)
  {
    std::string::const_iterator itr0, itr;
    itr0 = line.begin(); itr = itr0;

    while ((itr != line.end()) && (*itr != '\t')) ++itr;
    if (itr == line.end()) return E_FAIL;
    set_account(std::string(itr0, itr));
    ++itr;
    itr0 = itr;

    while ((itr != line.end()) && (*itr != '\t')) ++itr;
    if (itr == line.end()) return E_FAIL;
    set_script_host(std::string(itr0, itr));
    ++itr;
    itr0 = itr;

    while ((itr != line.end()) && (*itr != '\t')) ++itr;
    if (itr == line.end()) return E_FAIL;
    set_script_name(std::string(itr0, itr));
    ++itr;
    itr0 = itr;

    while ((itr != line.end()) && (*itr != '\t')) ++itr;
    if (itr == line.end()) return E_FAIL;
    set_script_option(std::string(itr0, itr));
    ++itr;
    itr0 = itr;

    set_script_ext(std::string(itr0, line.end()));

    set_script_id(uid);

    return S_OK;
  }

  std::string get_account(void) { return account; }
  std::string get_script_host(void) { return script_host; }
  std::string get_script_name(void) { return script_name; }
  std::string get_script_option(void) { return script_option; }
  UINT get_script_id(void) { return script_id; }
  std::string get_script_ext(void) { return script_ext; }

};

#endif // !defined(AFX_DZSCRIPT_H__373952F1_BA12_4F8D_8F3F_F8F3D46A48DE__INCLUDED_)
