/**
 * dzformatter.cpp
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "stdafx.h"

// newɗO𓊂邽
#include <new.h>
#include <new>

#include <htmlhelp.h>

#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>

#include "resource.h"

#include "aboutdlg.h"
#include "DzNode.h"
#include "DzDocument.h"
#include "RichEditView.h"
#include "BrowserView.h"
#include "DzScript.h"
#include "PipeThread.h"
#include "ChildProcess.h"
#include "MainFrm.h"

CAppModule _Module;

int ThrowBadAlloc(size_t)
{
  throw std::bad_alloc();
  return 0;
}

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{

  CMessageLoop theLoop;

	_Module.AddMessageLoop(&theLoop);

	CMainFrame wndMain;

	if(wndMain.CreateEx() == NULL)
	{
		ATLTRACE(_T("Main window creation failed!\n"));
		return 0;
	}

	wndMain.ShowWindow(nCmdShow);

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();

	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
  _set_new_handler(ThrowBadAlloc);

  DWORD dwCookie = NULL;
  HtmlHelp(NULL, NULL, HH_INITIALIZE, (DWORD)&dwCookie);

  // b`GfBbgRg[
  HINSTANCE hRich = LoadLibrary(CRichEditCtrl::GetLibraryName());
  if(hRich == NULL){
    AtlMessageBox(NULL, _T("b`GfBbgRg[s"),
      _T("G["), MB_OK | MB_ICONERROR);
    return 0;
  }

	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

  AtlAxWinInit();

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

  FreeLibrary(hRich);

  HtmlHelp(NULL, NULL, HH_UNINITIALIZE, (DWORD)dwCookie);

	return nRet;
}
