/**
 * dz2xml.js
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */


/* 萔 */
var nt_none = 0;
var nt_document = 1;
var nt_section = 2;
var nt_section_inner = 3;
var nt_outer = 4;
var nt_inner = 5;

/* O[oϐ */
var g_xdocstr = "";
var g_xdoc = new Array();
var g_nodeStack = new Array();
var g_prediv = "";

var fs = new ActiveXObject("Scripting.FileSystemObject");
var sh = new ActiveXObject("WScript.Shell");
var objArgs = WScript.Arguments;

/* C[` */
do_main();
WScript.Quit(0);

// ̃C[`
function do_main() {
  var hr = 0;

  if (objArgs.length != 2) {
    WScript.Echo("usage: dz2xml.js inputfile outputfile");
    WScript.Quit(-1);
  }

  /* t@Cǂݍ */
  var tsi = WScript.StdIn;
  if (objArgs(0) != "-") {
    var ForReading = 1;
    try {
      tsi = fs.OpenTextFile(objArgs(0), ForReading, true);
    } catch (e) {
      WScript.Echo("failed to open input file.\n");
      WScript.Quit(-1);
    }
  }

  hr = dzload(tsi, WScript.StdErr);
  if (objArgs(0) != "-") {
    tsi.Close();
  }
  if (hr) WScript.Quit(hr);
  
  // t@Co
  var tso = WScript.StdOut;
  if (objArgs(1) != "-") {
    var ForWriting = 2;
    try {
      tso = fs.OpenTextFile(objArgs(1), ForWriting, true);
    } catch (e) {
      WScript.Echo("failed to open output file.\n");
      WScript.Quit(-1);
    }
  }
  
  hr = dzsave(tso);
  if (hr) WScript.Quit(hr);
  if (objArgs(1) != "-") {
    tso.Close();
  }
}

// C[`I

function inc_itr(dzl) {
  ++dzl.itr;
  return 0;
}

function addinc_itr(dzldst, dzl) {
  if (dzl.line.charAt(dzl.itr) == "<") {
    dzldst.str += "&lt;";
  } else if (dzl.line.charAt(dzl.itr) == ">") {
    dzldst.str += "&gt;";
  } else if (dzl.line.charAt(dzl.itr) == "&") {
    dzldst.str += "&amp;";
  } else {
    dzldst.str += dzl.line.charAt(dzl.itr);
  }
  ++dzl.itr;
  return 0;
}

function nodeHeader2xmlNode(nh, dzl) {
  dzl.str = "<";
  dzl.str += nh.m_cmd;
  if (nh.m_class) {
    dzl.str += " class=\"" + nh.m_class + "\"";
  }
  if (nh.m_id) {
    dzl.str += " id=\"" + nh.m_id + "\"";
  }
  var i = 0;
  if (nh.m_vars) {
    for (var i = 0; i < nh.m_vars.length; i++) {
      dzl.str += " param" + i + "=\"" + nh.m_vars[i] + "\"";
    }
  }
  dzl.str += ">";
  return 0;
}

function tokenizeCommandLine(dzl, nh) {
  var hr = 0;
  var basecmd = dzl.line.charAt(0);

  // xZo
  nh.m_level = 0;
  while (dzl.line.charAt(dzl.itr) == basecmd) {
    hr = inc_itr(dzl);
    if (hr) return hr;
    ++nh.m_level;
  }
  
  if (basecmd == '|') {
    // ėpubN̏ꍇ
    if (dzl.line.charAt(dzl.itr) == '{') {
      // commandL
      // { }ň͂܂ꂽ͂NodeHeaderIuWFNgnhɊi[
      hr = inc_itr(dzl);
      if (hr) return hr;
      hr = parseInBrace(dzl, nh, "div", "}");
      if (hr) return hr;
      // itr{ }̊O
      hr = inc_itr(dzl);
      if (hr) return hr;
      g_prediv = nh.m_cmd;
    } else {
      if (g_prediv == "") {
        nh.m_cmd = "div";
      } else {
        nh.m_cmd = g_prediv;
      }
    }
  } else {
    // \sLubN̏ꍇ
    // m_cmd m
    if (basecmd == '*') nh.m_cmd = "section";
    else if (basecmd == '-') nh.m_cmd = "list";
    else if (basecmd == '>') nh.m_cmd = "blockquote";
    else if (basecmd == '!') nh.m_cmd = "dlist";
    
    if ((dzl.itr != dzl.line.length) && (dzl.line.charAt(dzl.itr) == '(')) {
      // sL̎'('΁ANXAID擾
      // ( ) ̓ɃCe[^i߂
      ++dzl.itr;
      if (dzl.itr == dzl.line.length) return -1;
      hr = parseInParen(dzl, nh, ")");
      if (hr) return hr;
      // itr( )̊O
      ++dzl.itr;
    }
  }
  // R}hw蕔ɕ񂪑ꍇ́AԂɋ󔒂1ȂĂ͂ȂȂ
  if (dzl.itr != dzl.line.length) {
    if (dzl.line.charAt(dzl.itr) != ' ') return -1;
    ++dzl.itr;
  }
  return hr;
}

function parseInParen(dzl, nh, stopChar) {
  var hr = 0;
  var isClassId = 0;
  var itr0 = dzl.itr;
  while (true) {
    if (dzl.line.charAt(dzl.itr) == ' ') {
      return -1;
    } else if (((dzl.itr == dzl.line.length) && (stopChar == "")) ||
               (stopChar.indexOf(dzl.line.charAt(dzl.itr)) != -1)) {
      if (isClassId == 0) {
        nh.m_class = dzl.line.substr(itr0, dzl.itr - itr0);
      } else {
        nh.m_id = dzl.line.substr(itr0, dzl.itr - itr0);
      }
      break;
    } else if (dzl.itr == dzl.line.length) {
      return -1;
    } else if (dzl.line.charAt(dzl.itr) == '#') {
      if (isClassId == 0) {
        nh.m_class = dzl.line.substr(itr0, dzl.itr - itr0);
        ++dzl.itr;
        itr0 = dzl.itr;
        isClassId = 1;
      } else {
        // #2ȏ㌻ꂽG[
        return -1;
      }
    }
    hr = inc_itr(dzl);
    if (hr) return hr;
  }
  return hr;
}

function parseInBrace(dzl, nh, defaultNodeName, stopChar) {
  var hr = 0;

  // R}hm
  nh.m_cmd = defaultNodeName;
  if ((dzl.itr != dzl.line.length) &&
      (stopChar.indexOf(dzl.line.charAt(dzl.itr)) == -1) &&
      (dzl.line.charAt(dzl.itr) != ' ') &&
      (dzl.line.charAt(dzl.itr) != '(')) {
    var itr0 = dzl.itr;
    while ((dzl.itr != dzl.line.length) && 
           (stopChar.indexOf(dzl.line.charAt(dzl.itr)) == -1) &&
           (dzl.line.charAt(dzl.itr) != ' ') &&
           (dzl.line.charAt(dzl.itr) != '(')) {
      hr = inc_itr(dzl);
      if (hr) return hr;
    }
    nh.m_cmd = dzl.line.substr(itr0, dzl.itr - itr0);
  }

  // class,id̏
  if (dzl.line.charAt(dzl.itr) == '(') {
    // class,id
    ++dzl.itr;
    hr = parseInParen(dzl, nh, ")");
    if (hr) return hr;
    ++dzl.itr;
  }
  
  // 󔒂̓ǂݔ΂
  while ((dzl.itr != dzl.line.length) &&
    (stopChar.indexOf(dzl.line.charAt(dzl.itr)) == -1) &&
    (dzl.line.charAt(dzl.itr) == ' ')) ++dzl.itr;

  // vars̏
  while (dzl.itr != dzl.line.length) {
    if (stopChar.indexOf(dzl.line.charAt(dzl.itr)) != -1) {
//      hr = inc_itr(itr, itr_end);
//      if (hr) return hr;
      break;
    } else if (dzl.line.charAt(dzl.itr) == '"') { // double quoted
      ++dzl.itr;
      var itr0 = dzl.itr;
      var strvar = new String();
      while (true) {
        if (dzl.itr == dzl.line.length) return -1;
        if (dzl.line.charAt(dzl.itr) == '"') break;
        if (dzl.line.charAt(dzl.itr) == '\\') {
          strvar += dzl.line.substr(itr0, dzl.itr - itr0);
          ++dzl.itr;
          if (dzl.itr == dzl.line.length) return -1;
          itr0 = dzl.itr;
        }
        hr = inc_itr(dzl);
        if (hr) return hr;
      }
      strvar += dzl.line.substr(itr0, dzl.itr - itr0);
      if (!nh.m_vars) {
        nh.m_vars = new Array();
      }
      strvar = strvar.replace(/&/g, "&amp;");
      strvar = strvar.replace(/</g, "&lt;");
      strvar = strvar.replace(/>/g, "&gt;");
      nh.m_vars.push(strvar);
      ++dzl.itr;
    } else { // not quoted
      var itr0 = dzl.itr;
      while (true) {
        if ((dzl.itr == dzl.line.length) || 
            (dzl.line.charAt(dzl.itr) == ' ') || 
            (stopChar.indexOf(dzl.line.charAt(dzl.itr)) != -1)) {
          break;
        }
        hr = inc_itr(dzl);
        if (hr) return hr;
      }
      if (!nh.m_vars) {
        nh.m_vars = new Array();
      }
      var strvar = dzl.line.substr(itr0, dzl.itr - itr0);
      strvar = strvar.replace(/&/g, "&amp;");
      strvar = strvar.replace(/</g, "&lt;");
      strvar = strvar.replace(/>/g, "&gt;");
      nh.m_vars.push(strvar);
    }
    while ((dzl.itr != dzl.line.length) && (dzl.line.charAt(dzl.itr) == ' ')) ++dzl.itr;
  }
  return hr;
}

function parseInLine(dzlnode, dzl, stopChar) {
  var hr = 0;
  while (dzl.itr != dzl.line.length) {
    if (stopChar.indexOf(dzl.line.charAt(dzl.itr)) != -1) {
      break;
    } else if (dzl.line.charAt(dzl.itr) == '_') {
      ++dzl.itr;
      if (dzl.itr == dzl.line.length) return -1;

      var dzlnode1 = new Object();
      dzlnode1.str = "";
      hr = parseInLine(dzlnode1, dzl, "[*{");
      if (hr) return hr;
      if (dzl.line.charAt(dzl.itr) == '[') {
        // ruby
        ++dzl.itr;
        if (dzl.itr == dzl.line.length) return -1;
        var ruby = new Object();
        ruby.str = "";
        while (dzl.line.charAt(dzl.itr) != ']') {
          if (dzl.line.charAt(dzl.itr) == '\\') {
            ++dzl.itr;
            if (dzl.itr == dzl.line.length) return -1;
          }
          hr = addinc_itr(ruby, dzl);
          if (hr) return hr;
          if (dzl.itr == dzl.line.length) return -1;
        }
        dzlnode.str += "<ruby param0=\"" + ruby.str + "\">" + dzlnode1.str + "</ruby>";
        ++dzl.itr;
      } else if (dzl.line.charAt(dzl.itr) == '*') { // emph
        dzlnode.str += "<em>" + dzlnode1.str + "</em>";
        ++dzl.itr;
      } else if (dzl.line.charAt(dzl.itr) == '{') { // general
        var nh1 = new Object();
        ++dzl.itr;
        if (dzl.itr == dzl.line.length) return 0;
        hr = parseInBrace(dzl, nh1, "span", "}");
        if (hr) return hr;
        // itr{ }̊O
        hr = inc_itr(dzl);
        if (hr) return hr;
        var strelem = new Object();
        strelem.str = "";
        hr = nodeHeader2xmlNode(nh1, strelem);
        dzlnode.str += strelem.str + dzlnode1.str + "</" + nh1.m_cmd + ">";
      } else {
        return -1;
      }
    } else if (dzl.line.charAt(dzl.itr) == '\\') {
      ++dzl.itr;
      if (dzl.itr == dzl.line.length) return -1;
      hr = addinc_itr(dzlnode, dzl);
      if (hr) return hr;
    } else {
      hr = addinc_itr(dzlnode, dzl);
      if (hr) return hr;
    }
  }
  return hr;
}

function parseBlankLine() {
  var hr = 0;
  while ((g_nodeStack.length > 0) &&
         (g_nodeStack[g_nodeStack.length - 1].m_type != nt_document) &&
         (g_nodeStack[g_nodeStack.length - 1].m_type != nt_section)) {
    g_xdoc.push("</" + g_nodeStack[g_nodeStack.length - 1].m_cmd + ">");
    g_nodeStack.pop();
  }
  return hr;
}

function parseOneLine(dzl) {
  var hr = 0;

  ++dzl.itr;
  if ((dzl.itr == dzl.line.length) ||
    (dzl.line.charAt(dzl.itr) == ' ') ||
    (dzl.line.charAt(dzl.itr) == '(')) {
    hr = -1;
    return hr;
  }
  var nh = new Object();
  hr = parseInBrace(dzl, nh, "div", "");
  if (hr) return hr;
  var dzlnode = new Object();
  dzlnode.str = "";
  hr = nodeHeader2xmlNode(nh, dzlnode);
  g_xdoc.push(dzlnode.str + "</" + nh.m_cmd + ">");

  return hr;
}

function parseSectionLine(dzl) {
  var hr = 0;
  var nh = new Object();

  hr = tokenizeCommandLine(dzl, nh);
  if (hr) return hr;

  // Jg̃ZNVxZo
  var nestlevel = 0;
  for (var i = g_nodeStack.length; i > 0; --i) {
    if (g_nodeStack[i - 1].m_type == nt_document) break;
    if (g_nodeStack[i - 1].m_type == nt_section) ++nestlevel;
  }
  // ʂ̃ZNV͕
  while (nestlevel >= nh.m_level) {
    if (g_nodeStack[g_nodeStack.length - 1].m_type == nt_document) return -1;
    if (g_nodeStack[g_nodeStack.length - 1].m_type == nt_section) --nestlevel;
    g_xdoc.push("</" + g_nodeStack[g_nodeStack.length - 1].m_cmd + ">");
    g_nodeStack.pop();
  }
  if (nestlevel < nh.m_level - 1) { // ZNVxɔтꍇ͉ʂ͂
    ++nestlevel;
    g_xdoc.push("<section>");
    var nh1 = new Object();
    nh1.m_cmd = "section";
    nh1.m_level = nestlevel;
    nh1.m_type = nt_section;
    g_nodeStack.push(nh1);
  }
  
  // ZNVJn
  {
    ++nestlevel;
    var dzlnode = new Object();
    dzlnode.str = "";
    nodeHeader2xmlNode(nh, dzlnode);
    g_xdoc.push(dzlnode.str);
    nh.m_type = nt_section;
    g_nodeStack.push(nh);
  }

  if (dzl.itr != dzl.line.length) {
    // heading
    g_xdoc.push("<heading>");
    var dzlnode1 = new Object();
    dzlnode1.str = "";
    hr = parseInLine(dzlnode1, dzl, "");
    if (hr) return hr;
    g_xdoc.push(dzlnode1.str);
    g_xdoc.push("</heading>");
  }
  return hr;
}

function parseDivLine(dzl) {
  var hr = 0;
  var nh = new Object();
  var strcmd_inner = "div_inner";
  switch(dzl.line.charAt(dzl.itr)) {
    case '-':
    strcmd_inner = "litem";
    break;
    case '>':
    strcmd_inner = "blockquote_inner";
    break;
    case '!':
    strcmd_inner = "ddesc";
    break;
    case '|':
    strcmd_inner = "div_inner";
    break;
  }
  hr = tokenizeCommandLine(dzl, nh);
  if (hr) return hr;
  // Jg̃XgxZo
  var nestlevel = 0;
  for (i = g_nodeStack.length; i > 0; --i) {
    if (g_nodeStack[i - 1].m_type == nt_document) break;
    if (g_nodeStack[i - 1].m_type == nt_section) break;
    if (g_nodeStack[i - 1].m_type == nt_outer) {
      ++nestlevel;
    } else if (g_nodeStack[i - 1].m_type == nt_inner) {
    } else {
      nestlevel = 0;
    }
  }
  
  // [lXg\͕
  while (nestlevel >= nh.m_level) {
    while (g_nodeStack[g_nodeStack.length - 1].m_type != nt_outer) {
      g_xdoc.push("</" + g_nodeStack[g_nodeStack.length - 1].m_cmd + ">\n");
      g_nodeStack.pop();
      if (g_nodeStack[g_nodeStack.length - 1].m_type == nt_document) return -1;
    }
    if (nestlevel == nh.m_level) break;
    g_xdoc.push("</" + g_nodeStack[g_nodeStack.length - 1].m_cmd + ">\n");
    g_nodeStack.pop();
    --nestlevel;
    if (g_nodeStack[g_nodeStack.length - 1].m_type == nt_document) return -1;
  }
  // ŌɊJĂlXgouter\擾
  var ni = 0;
  for (ni = g_nodeStack.length; ni > 0; --ni) {
    if ((g_nodeStack[ni - 1].m_type == nt_document) ||
        (g_nodeStack[ni - 1].m_type == nt_section) ||
        (g_nodeStack[ni - 1].m_type == nt_outer)) break;
  }
  // VKNXJn̏ꍇ͂ɈlXg\AVlXg\Jn
  if ((nh.m_class) ||
      (nh.m_id) ||
      ((nestlevel == nh.m_level) && (nh.m_cmd != g_nodeStack[ni - 1].m_cmd))) {
    while (nestlevel == nh.m_level) {
      g_xdoc.push("</" + g_nodeStack[g_nodeStack.length - 1].m_cmd + ">");
      if (g_nodeStack[g_nodeStack.length - 1].m_type == nt_outer) {
        g_nodeStack.pop();
        --nestlevel;
        if (nestlevel < nh.m_level) break;
      }
      g_nodeStack.pop();
    }
    var dzlnode = new Object();
    dzlnode.str = "";
    nodeHeader2xmlNode(nh, dzlnode);
    g_xdoc.push(dzlnode.str);
    var nh1 = new Object;
    nh1.m_cmd = nh.m_cmd;
    nh1.m_type = nt_outer;
    if (nh.m_class) {
      nh1.m_class = nh.m_class;
      nh.m_class = null;
    }
    if (nh.m_id) {
      nh1.m_id = nh.m_id;
      nh.m_id = null;
    }
    if (nh.vars) {
      nh1.m_vars = nh.vars;
      nh.vars = null;
    }
    g_nodeStack.push(nh1);
    ++nestlevel;
  }
  if (nestlevel == nh.m_level - 1) {
    var dzlnode = new Object();
    dzlnode.str = "";
    nodeHeader2xmlNode(nh, dzlnode);
    g_xdoc.push(dzlnode.str);
    var nh1 = new Object;
    nh1.m_cmd = nh.m_cmd;
    nh1.m_type = nt_outer;
    g_nodeStack.push(nh1);
    ++nestlevel;
  }
  if (nestlevel < nh.m_level - 1) { // Xgxɔтꍇ̓G[
    return -1;
  }

  // Xgeꍇ͓eǉ
  if (dzl.itr != dzl.line.length) {
    if (nh.m_cmd == "dlist") { // dlist̏ꍇ
      g_xdoc.push("<dterm>");
      var dzldterm = new Object;
      dzldterm.str = "";
      hr = parseInLine(dzldterm, dzl, ":");
      if (hr) return hr;
      g_xdoc.push(dzldterm.str);
      g_xdoc.push("</dterm>");
      hr = inc_itr(dzl);
      if (hr) return hr;
    }
    nh.m_cmd = strcmd_inner;
    g_xdoc.push("<" + nh.m_cmd + ">");
    nh.m_type = nt_inner;
    g_nodeStack.push(nh);
    var dzlnode = new Object;
    dzlnode.str = "";
    hr = parseInLine(dzlnode, dzl, "");
    if (hr) return hr;
    g_xdoc.push(dzlnode.str);
  }
  return hr;
}

function parseDefaultLine(dzl) {
  var hr = 0;
  // ZNVȊÕubN
  while ((g_nodeStack[g_nodeStack.length - 1].m_type != nt_section) &&
         (g_nodeStack[g_nodeStack.length - 1].m_type != nt_document)) {
    g_xdoc.push("</" + g_nodeStack[g_nodeStack.length - 1].m_cmd + ">");
    g_nodeStack.pop();
  }
  var dzlnode = new Object;
  dzlnode.str = "";
  hr = parseInLine(dzlnode, dzl, "");
  g_xdoc.push("<paragraph>");
  g_xdoc.push(dzlnode.str);
  g_xdoc.push("</paragraph>");
  return hr;
}

function parseLine(dzl) {
  var hr = 0;
  if ((dzl.itr == dzl.line.length) || (dzl.line.charAt(dzl.itr) == '\r') || (dzl.line.charAt(dzl.itr) == '\n')) {
    hr = parseBlankLine();
    if (hr) return hr;
    return hr;
  }
  if (dzl.line.charAt(dzl.itr) != '|') {
    g_prediv = "";
  }
  switch(dzl.line.charAt(dzl.itr)) {
  case ';': // Rg
    break;
  case '#': // vvZbT
    break;
  case ':': // 1sR}h
    hr = parseOneLine(dzl);
    if (hr) return hr;
    g_xdoc.push("\n");
    break;
  case '*': // section
    hr = parseSectionLine(dzl);
    if (hr) return hr;
    g_xdoc.push("\n");
    break;
  case '-':
  case '>':
  case '!':
  case '|':
    hr = parseDivLine(dzl);
    if (hr) return hr;
    g_xdoc.push("\n");
    break;
  default:
    hr = parseDefaultLine(dzl);
    if (hr) return hr;
    g_xdoc.push("\n");
  }
  return hr;
}

function dzload(istr, estr)
{
  var hr = 0;
  var linecnt = 0;
  g_xdocstr = "";
  g_xdoc = [];
  g_nodeStack = [];
  g_xdoc.push("<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
  g_xdoc.push("<document>\n");
  var nh = new Object();
  nh.m_type = nt_document;
  nh.m_cmd = "document";
  g_nodeStack.push(nh);
  while (!istr.AtEndOfStream) {
    var dzl = new Object;
    dzl.line = istr.ReadLine();
    dzl.itr = 0;
    dzl.str = "";
    linecnt++;
    hr = parseLine(dzl);
    if (hr) {
      estr.Write("dzparse failed at line: " + linecnt);
      return hr;
    }
  }
  while (g_nodeStack.length > 0) {
    g_xdoc.push("</" + g_nodeStack[g_nodeStack.length - 1].m_cmd + ">");
    g_nodeStack.pop();
  }
  g_xdocstr = g_xdoc.join("");
  return hr;
}

function dzsave(ostr)
{
  ostr.Write(g_xdocstr);
  return 0;
}
