/**
 * xml2txt.js
 * Copyright (C) 2006 Kazuyoshi Kakihara
 *
 * This file is part of dzformatter.
 *
 * dzformatter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

/*
 * Usage
 * cscript.exe xml2txt.js -i -o output_filename [input_filename]
 * -i 摜̃LvV{ɖߍ
 * -o o̓t@C
 */

// IvVڏݒ
var option = new Object();

// 摜̃LvV{ɖߍނǂi0:ߍ܂Ȃ 1:ߍށj
option.image_comment = 0;

// o̓t@C
option.output_filename = "-";

// ̓t@C
option.input_filename = "-";

// IvVځ@܂

// O[oϐ
var fs = new ActiveXObject("Scripting.FileSystemObject");
var xmldoc = new ActiveXObject("Msxml2.DOMDocument");
var sh = new ActiveXObject("WScript.Shell");
var objArgs = WScript.Arguments;
var ForReading = 1;
var ForWriting = 2;

var CRLF = "\r\n";

do_main();
WScript.Quit(0);

// ̃C[`
function do_main() {
  var tso;
  var xmlgv = new Object();
  xmlgv.xmlidsection = new Array();
  xmldoc.async = false;
  xmldoc.resolveExternals = false;
  xmldoc.preserveWhiteSpace = true;

  { // R}hC
    for (var i = 0; i < objArgs.length; ++i) {
      if (objArgs(i) == "-i") {
        option.image_comment = 1;
      } else if (objArgs(i) == "-o") {
        ++i;
        if (i > objArgs.length) {
          WScript.StdErr.Write("-o.\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.output_filename = objArgs(i);
      } else {
        if (i + 1 != objArgs.length) {
          WScript.StdErr.Write(objArgs(i) + ".\n");
          WScript.StdErr.Write("invalid arguments.\n");
          WScript.Quit(-1);
        }
        option.input_filename = objArgs(i);
      }
    }
  }

  // t@Cǂݍ
  {
    var srcArr = new Array();
    if (option.input_filename != "-") {
      var tsi;
      try {
        tsi = fs.OpenTextFile(option.input_filename, ForReading);
      } catch (e) {
        WScript.StdErr.Write("failed to open input file.\n");
        WScript.Quit(-1);
      }
      while (!tsi.AtEndOfStream) {
        srcArr.push(tsi.ReadLine());
      }
      tsi.Close();
    } else {
      while (!WScript.StdIn.AtEndOfStream) {
        srcArr.push(WScript.StdIn.ReadLine());
      }
    }
    xmldoc.loadXML(srcArr.join(""));
  }

  // ^Cgoi[쐬
  var strbanner = generate_banner(xmldoc, xmlgv);
  
  // ڎ
  var strindex = generate_index(xmldoc, xmlgv);

  // {
  var strbody = xml2string(xmldoc, xmlgv);

  // t@Co
  // t@Co
  tso = WScript.StdOut;
  if (option.output_filename != "-") {
    try {
      tso = fs.OpenTextFile(option.output_filename, ForWriting, true);
    } catch(e) {
      WScript.StdErr.Write("failed to open output file.\n");
      WScript.Quit(-1);
    }
  }
  tso.write(strbanner);
  tso.write(strindex);
  tso.Write(strbody);
  if (option.output_filename != "-") {
    tso.Close();
  }

  // C[`I
  return 0;
}

function getByteLength(str) {
  var len = 0;
  for (var i = 0; i < str.length; ++i) {
    var c = str.charCodeAt(i);
    if ((c >= 0x0 && c < 0x81) || (c == 0xf8f0) || (c >= 0xff61 && c < 0xffa0) || (c >= 0xf8f1 && c < 0xf8f4)) {
      ++len;
    } else {
      len += 2;
    }
  }
  return len;
}

function generate_banner(xmldoc, xmlgv) {
  var strarr = new Array();
  var objNodeList;
  var strtitle = "", strauthor = "", strdate = "";

  objNodeList = xmldoc.getElementsByTagName("title");
  if (objNodeList.length > 0) {
    strtitle = objNodeList.item(0).getAttribute("param0");
  }
  objNodeList = xmldoc.getElementsByTagName("author");
  if (objNodeList.length > 0) {
    strauthor = objNodeList.item(0).getAttribute("param0");
  }
  objNodeList = xmldoc.getElementsByTagName("date");
  if (objNodeList.length > 0) {
    strdate = objNodeList.item(0).getAttribute("param0");
  }
  if ((strtitle + strauthor + strdate).length > 0) {
    strarr.push("#==============================================#");
    strarr.push(CRLF);
    if (strtitle.length > 0) {
      strarr.push(" " + strtitle);
      strarr.push(CRLF);
    }
    if (strauthor.length > 0) {
      strarr.push("                                                ".substr(0, 47 - getByteLength(strauthor)) + strauthor);
      strarr.push(CRLF);
    }
    if (strdate.length > 0) {
      strarr.push("                                                ".substr(0, 47 - getByteLength(strdate)) + strdate);
      strarr.push(CRLF);
    }
    strarr.push("#==============================================#");
    strarr.push(CRLF);
  }
  strarr.push(CRLF);
  strarr.push(CRLF);

  return (strarr.join(""));
}

// ڎ
function generate_index(xmldoc, xmlgv) {
  var strarr = new Array();
  var objNodeList;
  xmlgv.hlevel = 0;
  xmlgv.section = 0;
  xmlgv.count = 0;

  parse_xmlnode_for_index(xmldoc.documentElement, strarr, "");

  return (strarr.join(""));
}

function parse_xmlnode_for_text(xmlnode, strarr) {
  var nl = xmlnode.childNodes;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    if (nd.nodeType == 3) { // TEXT NODE
      var str1 = nl.item(i).text;
      strarr.push(str1);
    }
  }
  return 0;
}

function parse_xmlnode_for_index(xmlnode, strarr, strpre) {
  var nl = xmlnode.childNodes;
  var section = 0;

  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    var str = new String();
    if (nd.nodeType == 1) { // Element
      var strid = nd.getAttribute("id");
      if (nd.nodeName == "section") {
        var strheading = "section";
        var objNodeList = nd.getElementsByTagName("heading");
        if (objNodeList.length > 0) {
          var strheadingarr = new Array();
          parse_xmlnode_for_text(objNodeList.item(0), strheadingarr);
          strheading = strheadingarr.join("");
        }
        
        ++section;
        var strsection = section.toString(10);
//        if (section < 1000) {
//          strsection = ("   " + strsection).substr(strsection.length, 3);
//        }
        strarr.push(strpre + strsection + ". " + strheading);
        strarr.push(CRLF);
        // child section΁AqXg쐬
        var objNodeList = nd.getElementsByTagName("section");
        if (objNodeList.length > 0) {
          parse_xmlnode_for_index(nd, strarr, strpre + strsection + ".");
        }
      }
    }
  }
  return 0;
}

function xml2string(xmldoc, xmlgv) {
  var strarr = new Array();
  var objNodeList;
  xmlgv = new Object();
  xmlgv.hlevel = 0;
  xmlgv.llevel = 0;
  
  strarr.push(CRLF);
  strarr.push(CRLF);
  parse_xmlnode(xmldoc.documentElement, strarr, xmlgv, "");

  return strarr.join("");
}

function parse_xmlnode(xmlnode, strarr, xmlgv, sectionhead, linehead) {
  var nl = xmlnode.childNodes;
  var section = 0;
  
  for (var i = 0; i < nl.length; i++) {
    var nd = nl.item(i);
    var str = new String();
    if (nd.nodeType == 1) {
      if (nd.nodeName == "section") {
        ++section;
        ++xmlgv.hlevel;
        if (strarr[strarr.length - 1] != CRLF) {
          strarr.push(CRLF);
        }
        strarr.push(CRLF);
        objNodeList = xmldoc.getElementsByTagName("heading");
        if (objNodeList.length == 0) {
          strarr.push(sectionhead + section + ". ", "");
          strarr.push(CRLF);
        }
        
        parse_xmlnode(nd, strarr, xmlgv, sectionhead + section + ". ", "");
        --xmlgv.hlevel;
      } else if (nd.nodeName == "heading") {
        if (xmlgv.hlevel == 1) {
          strarr.push(CRLF);
          strarr.push("#================================================");
          strarr.push(CRLF);
          strarr.push("# ");
        } else if (xmlgv.hlevel == 2) {
          strarr.push("#--------------------------------");
          strarr.push(CRLF);
          strarr.push("# ");
        }
        strarr.push(sectionhead);
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, "");
        if (xmlgv.hlevel == 1) {
          strarr.push(CRLF);
          strarr.push("#================================================");
          strarr.push(CRLF);
        } else if (xmlgv.hlevel == 2) {
          strarr.push(CRLF);
          strarr.push("#--------------------------------");
          strarr.push(CRLF);
        } else if (xmlgv.hlevel == 3) {
          strarr.push(CRLF);
          strarr.push("--------------------");
//          strarr.push(CRLF);
        } else {
          strarr.push(CRLF);
        }
        strarr.push(CRLF);
      } else if (nd.nodeName == "list") {
        ++xmlgv.llevel;
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead);
        --xmlgv.llevel;
      } else if (nd.nodeName == "litem") {
        var strl = "";
        if (strarr[strarr.length - 1] != CRLF) {
          strarr.push(CRLF);
        }
        for (var ii = 0; ii < xmlgv.llevel; ++ii) {
          strl += "-";
        }
        strarr.push(strl + " ");
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead);
      } else if (nd.nodeName == "blockquote") {
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead + ">");
      } else if (nd.nodeName == "blockquote_inner") {
        if (strarr[strarr.length - 1] != CRLF) {
          strarr.push(CRLF);
        }
        strarr.push(linehead + " ");
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead);
      } else if (nd.nodeName == "dlist") {
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead + "!");
      } else if (nd.nodeName == "dterm") {
        if (strarr[strarr.length - 1] != CRLF) {
          strarr.push(CRLF);
        }
        strarr.push("[");
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead);
        strarr.push("] ");
      } else if (nd.nodeName == "ddesc") {
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead);
      } else if (nd.nodeName == "paragraph") {
        if (strarr[strarr.length - 1] != CRLF) {
          strarr.push(CRLF);
        }
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead);
        strarr.push(CRLF);
      } else if (nd.nodeName == "div") {
        if (strarr[strarr.length - 1] != CRLF) {
          strarr.push(CRLF);
        }
        parse_xmlnode(nd, strarr, xmlgv, sectionhead, linehead);
        strarr.push(CRLF);
      } else if (nd.nodeName == "div_inner") {
        if (strarr[strarr.length - 1] != CRLF) {
          strarr.push(CRLF);
        }
        parse_xmlnode(nd, strarr, xmlgv);
      } else if (nd.nodeName == "ruby") {
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("(" + nd.getAttribute("param0") + ")");
      } else if (nd.nodeName == "em") {
        strarr.push("'");
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("'");
      } else if (nd.nodeName == "a") {
        parse_xmlnode(nd, strarr, xmlgv);
      } else if (nd.nodeName == "link") {
        parse_xmlnode(nd, strarr, xmlgv);
        strarr.push("(" + nd.getAttribute("param0") + ")");
      } else if (nd.nodeName == "rlink") {
        parse_xmlnode(nd, strarr, xmlgv);
      } else if (nd.nodeName == "image") {
        if (option.image_comment) {
          strarr.push("[摜] " + nd.getAttribute("param1"));
        }
      } else if (nd.nodeName == "hrz") {
        strarr.push("---- ---- ---- ----");
        strarr.push(CRLF);
      } else {
        // `^O
      }
    } else if (nd.nodeType == 3) { // TEXT_NODE
      var str1 = nl.item(i).text;
      str1 = str1.replace(/\r/g, "");
      str1 = str1.replace(/\n/g, "");
      if (str1.length > 0) strarr.push(str1);
    }
  }
  return 0;
}
