// getimagesize.c
//

#include <windows.h>
#include <shlwapi.h>

#include <stdio.h>

#pragma comment(lib, "shlwapi.lib") 


LPCSTR perr = NULL;

unsigned short readshort(HANDLE hin) {
  char buff[2];
  int i;
  DWORD dwRead;
  unsigned short s = 0;
  if (!ReadFile(hin, buff, 2, &dwRead, NULL)) {
    return -1;
  }
  if (dwRead < 2) return -1;
  for (i = 0; i < 2; ++i) {
    s <<= 8;
    s |= (unsigned char) buff[i];
  }
  return s;
}

unsigned long readlong(HANDLE hin) {
  char buff[4];
  int i;
  DWORD dwRead;
  unsigned long l = 0;
  if (!ReadFile(hin, buff, 4, &dwRead, NULL)) {
    return -1;
  }
  if (dwRead < 4) return -1;
  for (i = 0; i < 4; ++i) {
    l <<= 8;
    l |= (unsigned char) buff[i];
  }
  return l;
}

unsigned __int64 readi64(HANDLE hin) {
  char buff[8];
  int i;
  DWORD dwRead;
  unsigned __int64 i64 = 0;
  if (!ReadFile(hin, buff, 8, &dwRead, NULL)) {
    return -1;
  }
  if (dwRead < 8) return -1;
  for (i = 0; i < 8; ++i) {
    i64 <<= 8;
    i64 |= (unsigned char) buff[i];
  }
  return i64;
}

void getimagesize_jpg(HANDLE hin, int *ph, int *pw) {
  CHAR c;
  DWORD dwRead;

  while (ReadFile(hin, &c, 1, &dwRead, NULL)) {
    unsigned short len = 0;

    if ((UCHAR)c == 0xff) {
      if (!ReadFile(hin, &c, 1, &dwRead, NULL)) {
        perr = "Invalid jpeg file format.";
        return;
      }
      if ((UCHAR)c == 0xd8) { /* t@C̐擪 */
        continue;
      } else if ((UCHAR)c == 0xd9) { /* t@C̏I */
        return;
      }

      /* ubN擾 */
      {
        len = readshort(hin);
        if ((len == -1) || (len < 3)) {
          perr = "Invalid jpeg file format.";
          return;
        }
      }

      if (((UCHAR)c == 0xc0) || ((UCHAR)c == 0xc2)) {
        unsigned short sh, sw;
        if (!ReadFile(hin, &c, 1, &dwRead, NULL)) { /* 1oCgǂݔ΂ */
          perr = "Invalid jpeg file format.";
          return;
        }

        sh = readshort(hin);
        if (sh == -1) {
          perr = "Invalid jpeg file format.";
          return;
        }

        sw = readshort(hin);
        if (sw == -1) {
          perr = "Invalid jpeg file format.";
          return;
        }

        *ph = sh;
        *pw = sw;
        
        return;
      }

      SetFilePointer(hin, len - 2, NULL, FILE_CURRENT);
    } else {
      perr = "Invalid jpeg file format.";
      return;
    }
  }
  perr = "Invalid jpeg file format.";
  return;
}

void getimagesize_png(HANDLE hin, int *ph, int *pw) {
  DWORD dwRead;

  SetFilePointer(hin, 8, NULL, FILE_CURRENT);
  while (TRUE) {
    char cname[5];
    unsigned long len = 0;

    /* ubN擾 */
    {
      len = readlong(hin);
      if ((len == -1) || (len == 0)) {
        perr = "Invalid png file format.";
        return;
      }
    }

    if (!ReadFile(hin, cname, 4, &dwRead, NULL)) {
      perr = "Invalid png file format.";
      return;
    }
    if (dwRead != 4) {
      perr = "Invalid png file format.";
      return;
    }
    cname[4] = '\0';

    if (!lstrcmp(cname, "IHDR")) {
      unsigned long lw, lh;
      lw = readlong(hin);
      if (lw == -1) {
        perr = "Invalid png file format.";
        return;
      }
      lh = readlong(hin);
      if (lh == -1) {
        perr = "Invalid png file format.";
        return;
      }

      *ph = lh;
      *pw = lw;

      return;
    }

    SetFilePointer(hin, len + 4, NULL, FILE_CURRENT);
  }
  perr = "Invalid png file format.";
  return;
}

void getimagesize_gif(HANDLE hin, int *ph, int *pw) {
  unsigned short sh, sw;

  SetFilePointer(hin, 6, NULL, FILE_CURRENT);
  sw = readshort(hin);
  if (sw == -1) {
    perr = "Invalid gif file format.";
    return;
  }
  sh = readshort(hin);
  if (sh == -1) {
    perr = "Invalid gif file format.";
    return;
  }
  *ph = sh;
  *pw = sw;
  return;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
  int iRet = -1;
  int h = -1, w = -1;
  LPCSTR pext;
  HANDLE hin;

  if (__argc != 2) {
    perr = "Invalid Arguments number.";
    iRet = -1;
    goto finish_func;
  }

  pext = PathFindExtension(__argv[1]);
  if (pext == __argv[1]) {
    perr = "Invalid filename.";
    iRet = -1;
    goto finish_func;
  }

  hin = CreateFile(__argv[1], GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  if (hin == INVALID_HANDLE_VALUE) {
    DWORD dwErr = GetLastError();
    perr = "Failed to open file.";
    iRet = -1;
    goto finish_func;
  }

  if ((!lstrcmpi(pext, ".jpg")) ||
      (!lstrcmpi(pext, ".jpeg"))) {
    getimagesize_jpg(hin, &h, &w);
  } else if (!lstrcmpi(pext, ".png")) {
    getimagesize_png(hin, &h, &w);
  } else if (!lstrcmpi(pext, ".gif")) {
    getimagesize_gif(hin, &h, &w);
  }
  CloseHandle(hin);

finish_func:
  {
    DWORD dwWritten;
    CHAR buff[64];
    HANDLE hout;

    wsprintf(buff, "%d\r\n%d\r\n", w, h);
    hout = GetStdHandle(STD_OUTPUT_HANDLE);
    if (hout != INVALID_HANDLE_VALUE) {
      WriteFile(hout, buff, lstrlen(buff), &dwWritten, NULL);
    }
  }
    
  if (perr) {
    DWORD dwWritten;
    HANDLE herr;

    herr = GetStdHandle(STD_ERROR_HANDLE);
    if (herr != INVALID_HANDLE_VALUE) {
      WriteFile(herr, perr, lstrlen(perr), &dwWritten, NULL);
    }
  }
	return iRet;
}

